package com.example.rejestracjavideo;

import java.io.File;
import java.io.IOException;

import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.media.CamcorderProfile;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class MainActivity extends Activity implements SurfaceHolder.Callback {

	Button guzik;
	MediaRecorder mediaRecorder;
	SurfaceHolder surfaceHolder;
	SurfaceView surfaceView;
	boolean nagrywanie;
	String sciezkaPliku = "/sdcard/nagranie2.mp4";

	public void klikniecie() {
		if (nagrywanie) {
			mediaRecorder.stop();
			mediaRecorder.release();
			finish();
			File f = new File(sciezkaPliku);
			if (f.exists()) {
				Log.d("KAMERA", "Jest plik!");
			} else {
				Log.d("KAMERA", "Nie ma plika");
			}
		} else {
			mediaRecorder.start();
			nagrywanie = true;
			guzik.setText("Koniec");
		}
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		nagrywanie = false;
		mediaRecorder = new MediaRecorder();
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
		initMediaRecorder();
		surfaceView = (SurfaceView) findViewById(R.id.videoview);
		surfaceHolder = surfaceView.getHolder();
		surfaceHolder.addCallback(this);
		surfaceHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);		
		guzik = (Button) findViewById(R.id.mybutton);		
		OnClickListener l = new OnClickListener() {			
			@Override
			public void onClick(View v) {
				klikniecie();
			}
		};
		guzik.setOnClickListener(l);
	}



	@Override
	public void surfaceChanged(SurfaceHolder arg0, int arg1, int arg2, int arg3) {
		// TODO Auto-generated method stub

	}

	@Override
	public void surfaceCreated(SurfaceHolder arg0) {
		// TODO Auto-generated method stub
		prepareMediaRecorder();
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder arg0) {
		// TODO Auto-generated method stub

	}

	private void initMediaRecorder() {
		mediaRecorder.setAudioSource(MediaRecorder.AudioSource.DEFAULT);
		mediaRecorder.setVideoSource(MediaRecorder.VideoSource.DEFAULT);
		CamcorderProfile hq = CamcorderProfile.get(CamcorderProfile.QUALITY_HIGH);
		mediaRecorder.setProfile(hq);
		mediaRecorder.setOutputFile(sciezkaPliku);
		mediaRecorder.setMaxDuration(180000); //trzy minuty 
		mediaRecorder.setMaxFileSize(10000000); //10MB
	}

	private void prepareMediaRecorder() {
		mediaRecorder.setPreviewDisplay(surfaceHolder.getSurface());
		try {
			mediaRecorder.prepare();
		
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}